/* file: "mem.h" */

/* Copyright (C) 1994-1996 by Marc Feeley, All Rights Reserved. */

/*
 * Memory allocation parameters:
 *
 * ___MSECTION_SIZE is size in words of sections that contain movable objects
 * ___MSECTION_BIGGEST is size in words of biggest movable object
 * ___MSECTION_SMALLEST is size in words of smallest movable object
 * ___NORMAL_OVERFLOW_RESERVE is number of words reserved for heap overflows
 * ___STACK_SIZE is size in words of stack
 * ___STACK_FUDGE is size in words of stack fudge area
 * ___PSECTION_SIZE is size in words of sections that contain permanent objects
 * ___PSECTION_BIGGEST is size in words of biggest object in psections
 */

#define ___MIN_NB_MSECTIONS 2
#define ___MSECTION_SIZE           131072
#define ___MSECTION_BIGGEST        4096
#define ___MSECTION_SMALLEST       0
#define ___NORMAL_OVERFLOW_RESERVE 32768
#define ___STACK_SIZE              8192
#define ___STACK_FUDGE             4096
#define ___PSECTION_SIZE           1024
#define ___PSECTION_BIGGEST        32

extern void ___setup_mem (/* setup_params */);
extern int ___gc ();
extern int ___heap_limit ();

extern ___glo_struct *___alloc_global_var ();

extern ___WORD ___alloc_scmobj (/* subtype, bytes, kind */);
extern ___WORD ___make_pair (/* car, cdr, kind */);
extern ___WORD ___make_vector (/* length, init, kind */);
extern ___WORD ___make_string (/* length, init, kind */);
extern void ___still_obj_refcount_inc (/* obj */);
extern void ___still_obj_refcount_dec (/* obj */);
